*
*
* ====================================================
*
*   DIP1D.asm       Axiom DIP Switch Lab 
*                                 
*   Version:        1.0   Released 9/22/2003
*   Author:         Gary Karnes , Axiom Mfg.
*   Compiler:       As12
*       
*   Platform:       Axiom CME11-E9 EVBU
*   Purpose:        Lab Experiment
* 
* ====================================================
*
*        DIP Switch Display Program
*        HC11 code 
*
*        
PORTE:       equ     $100A        ; PORT E input resister
OUTPUT:      equ     $FFAF        ; Buffalo output routine
OUTCRLF:     equ     $FFC4        ; Buffalo routine CR/LF
OUTRHLF:     equ     $FFB5        ; Buffalo routine right nibble to AscII
*
             org     $0100        ; start address
*            
*             
Loop1
             bsr      OutBin      ; shift data and send 
             bsr      Delay       ; Delay for display   
             bra      Loop1         
*
*
* Output Acc A has 4 binary digits in AscII format
OutBin:
             jsr    OUTCRLF      ; new line, buffalo routine
             ldaa   PORTE        ; read DIP switch
             lsra                ; shift bits
             lsra                ; into position
             lsra                ; for display
             lsra
             lsla                ; ready A for display
             bsr    BitShift     ; send first bit
             bsr    BitShift     ; send second bit
             bsr    BitShift     ; send third bit
             bsr    BitShift     ; send fourth bit
             rts
*
* Shift bit for display
BitShift:
             lsra             ; next bit
             psha             ; save A
             anda   #$01      ; mask bit
             jsr    OUTRHLF   ; send right nibble has AscII
             pula             ; restore A
             rts
*
*
*
* Delay
Delay:
             ldab    #$04
DelayB
             ldy     #$FFFF 
DelayA:      
             dey                  
             bne     DelayA
             decb    
             bne     DelayB
             rts
*
*